define(['exports', 'aurelia-framework', 'hammerjs'], function (exports, _aureliaFramework, _hammerjs) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.MoSwipeCustomAttribute = undefined;

  var _hammerjs2 = _interopRequireDefault(_hammerjs);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  var _dec, _class;

  var MoSwipeCustomAttribute = exports.MoSwipeCustomAttribute = (_dec = (0, _aureliaFramework.inject)(Element), _dec(_class = function () {
    function MoSwipeCustomAttribute(element) {
      _classCallCheck(this, MoSwipeCustomAttribute);

      this.hammer = new _hammerjs2.default.Manager(element, {
        recognizers: [[_hammerjs2.default.Swipe, { direction: _hammerjs2.default.DIRECTION_HORIZONTAL }]]
      });
      this.element = element;
    }

    MoSwipeCustomAttribute.prototype.attached = function attached() {
      this.hammer.on('swipe', this.handleSwipe.bind(this));
    };

    MoSwipeCustomAttribute.prototype.detached = function detached() {
      this.hammer.off('swipe', this.handleSwipe.bind(this));
    };

    MoSwipeCustomAttribute.prototype.valueChanged = function valueChanged(newValue) {
      this.callback = newValue;
    };

    MoSwipeCustomAttribute.prototype.handleSwipe = function handleSwipe(event) {
      if (this.callback) {
        var direction = void 0;
        switch (event.direction) {
          case _hammerjs2.default.DIRECTION_LEFT:
            direction = 'left';
            break;
          case _hammerjs2.default.DIRECTION_RIGHT:
            direction = 'right';
            break;
          default:
            direction = null;
            break;
        }
        this.callback.call(null, { direction: direction, hammerEvent: event });
      }
    };

    return MoSwipeCustomAttribute;
  }()) || _class);
});