'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MoTapCustomAttribute = undefined;

var _dec, _class;

var _aureliaFramework = require('aurelia-framework');

var _hammerjs = require('hammerjs');

var _hammerjs2 = _interopRequireDefault(_hammerjs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var MoTapCustomAttribute = exports.MoTapCustomAttribute = (_dec = (0, _aureliaFramework.inject)(Element), _dec(_class = function () {
  function MoTapCustomAttribute(element) {
    _classCallCheck(this, MoTapCustomAttribute);

    this.hammer = new _hammerjs2.default.Manager(element, {
      recognizers: [[_hammerjs2.default.Tap]]
    });
    this.element = element;
  }

  MoTapCustomAttribute.prototype.attached = function attached() {
    this.hammer.on('tap', this.handleTap.bind(this));
  };

  MoTapCustomAttribute.prototype.detached = function detached() {
    this.hammer.off('tap', this.handleTap.bind(this));
  };

  MoTapCustomAttribute.prototype.valueChanged = function valueChanged(newValue) {
    this.callback = newValue;
  };

  MoTapCustomAttribute.prototype.handleTap = function handleTap(event) {
    if (this.callback) {
      this.callback.call(null, { hammerEvent: event });
    }
  };

  return MoTapCustomAttribute;
}()) || _class);