'use strict';

System.register(['aurelia-framework', 'hammerjs'], function (_export, _context) {
  "use strict";

  var inject, Hammer, _dec, _class, MoSwipeCustomAttribute;

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  return {
    setters: [function (_aureliaFramework) {
      inject = _aureliaFramework.inject;
    }, function (_hammerjs) {
      Hammer = _hammerjs.default;
    }],
    execute: function () {
      _export('MoSwipeCustomAttribute', MoSwipeCustomAttribute = (_dec = inject(Element), _dec(_class = function () {
        function MoSwipeCustomAttribute(element) {
          _classCallCheck(this, MoSwipeCustomAttribute);

          this.hammer = new Hammer.Manager(element, {
            recognizers: [[Hammer.Swipe, { direction: Hammer.DIRECTION_HORIZONTAL }]]
          });
          this.element = element;
        }

        MoSwipeCustomAttribute.prototype.attached = function attached() {
          this.hammer.on('swipe', this.handleSwipe.bind(this));
        };

        MoSwipeCustomAttribute.prototype.detached = function detached() {
          this.hammer.off('swipe', this.handleSwipe.bind(this));
        };

        MoSwipeCustomAttribute.prototype.valueChanged = function valueChanged(newValue) {
          this.callback = newValue;
        };

        MoSwipeCustomAttribute.prototype.handleSwipe = function handleSwipe(event) {
          if (this.callback) {
            var direction = void 0;
            switch (event.direction) {
              case Hammer.DIRECTION_LEFT:
                direction = 'left';
                break;
              case Hammer.DIRECTION_RIGHT:
                direction = 'right';
                break;
              default:
                direction = null;
                break;
            }
            this.callback.call(null, { direction: direction, hammerEvent: event });
          }
        };

        return MoSwipeCustomAttribute;
      }()) || _class));

      _export('MoSwipeCustomAttribute', MoSwipeCustomAttribute);
    }
  };
});